#ifndef sys_signal_h

/*
#ifdef LINUX
static id_before_bsd_signal_h = LINUX;
#include <bsd/signal.h>
static id_after_bsd_signal_h = LINUX;
#define sys_signal_h
#else
static id_no_bsd_signal_h = 0;
#endif
*/

#ifndef sys_signal_h
#include   <signal.h>
#include <sys/signal.h>
#define sys_signal_h
#endif

#if defined(SOLARIS) && !defined(sigmask)
/*
* The sigmask() macro is #defined in <sys/signal.h>, but  there  seems
* to  be  no  discernable way to get it to compile, so let's just copy
* the definition.  If someone learns how to trick  the  compiler  into
* recognizing the library definition, please fix it.
*/
#define  sigmask(n)     ((unsigned int)1 << (((n) - 1) & (32 - 1)))
#endif

#ifndef SIGCHLD
#ifdef  SIGCLD
#define SIGCHLD SIGCLD
#endif
#endif

#ifdef SunOS
	typedef void * sig_t;	/* Sun hasn't heard of this pseudo-type yet */
#endif

#ifdef IRIX64
	typedef void * sig_t;	/* Neither have the Irix folks */
#endif

#endif
